Subject: Re: bug#25930: optimize mv for multiple bind mounts

From: L A Walsh <[email-masked]>
Date: Thu, 02 Mar 2017 13:16:49 -0800

Sven Joachim wrote:
> ,----
> |   EXDEV  oldpath and newpath are not on the same mounted filesystem.
> |          (Linux  permits  a  filesystem  to  be  mounted at multiple
> |          points, but rename() does not work across  different  mount
> |          points, even if the same filesystem is mounted on both.)
>   
----
    That's unfortunate, as Windows recognizes moves between
the same device and does a rename vs. a copy (i.e. it doesn't
matter if the mounted object from the mount is different, as
long as the rename happens between the same devices).

    Seems like the linux kernel should have a check for that case.
(I.e. coreutils isn't likely the right place to try to fix this, since
you'd want the 'rename' optimization to happen no matter what tool
you used.

    Anyone know why Linux doesn't do detection by device vs.
by mount point?  Both pieces of info have their use, but for rename
seems that 'by device' would be optimal.